<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>48.50</title>
    <!--DataTable-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.6/css/dataTables.bootstrap4.min.css">

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Ionicons -->
    <link rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
    <!-- Tempusdominus Bootstrap 4 -->
    <link rel="stylesheet" href="plugins/tempusdominus-bootstrap-4/css/tempusdominus-bootstrap-4.min.css">
    <!-- iCheck -->
    <link rel="stylesheet" href="plugins/icheck-bootstrap/icheck-bootstrap.min.css">
    <!-- JQVMap -->
    <link rel="stylesheet" href="plugins/jqvmap/jqvmap.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <!-- overlayScrollbars -->
    <link rel="stylesheet" href="plugins/overlayScrollbars/css/OverlayScrollbars.min.css">
    <!-- Daterange picker -->
    <link rel="stylesheet" href="plugins/daterangepicker/daterangepicker.css">
    <!-- summernote -->
    <link rel="stylesheet" href="plugins/summernote/summernote-bs4.min.css">
    <style>
        label {
            width: 20%;
            margin: 20px 0 20px 100px;
        }

        select {
            width: 30% !important;
            margin: 20px;
        }

        button {
            width: 10%;
            height: 60px;
            margin-top: 10px;
        }
    </style>

</head>

<body class="hold-transition sidebar-mini layout-fixed">
    <div class="wrapper">

        <!-- Preloader -->
        <div class="preloader flex-column justify-content-center align-items-center">
            <img class="animation__shake" src="dist/img/AdminLTELogo.png" alt="AdminLTELogo" height="60" width="60">
        </div>

        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
            </ul>

            <!-- Right navbar links -->
            <ul class="navbar-nav ml-auto">
                <!-- Navbar Search -->

                <li class="nav-item">
                    <a class="nav-link" data-widget="fullscreen" href="#" role="button">
                        <i class="fas fa-expand-arrows-alt"></i>
                    </a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" data-widget="control-sidebar" data-controlsidebar-slide="true" href="#"
                        role="button">
                        <i class="fas fa-th-large"></i>
                    </a>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->

        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="index3.html" class="brand-link">
                <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
                    style="opacity: .8">
                <span class="brand-text font-weight-light">Admin User</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <!-- Sidebar user panel (optional) -->

                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
                        <li class="nav-item menu-open">
                            <a href="#" class="nav-link active">
                                <i class="nav-icon fas fa-tachometer-alt"></i>
                                <p>
                                    Admin
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>
                            <ul class="nav nav-treeview">
                                <li class="nav-item">
                                    <a href="48.30-main.html" class="nav-link ">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Voucher</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="48.40-main.html" class="nav-link ">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>User Signed up </p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="48.50-main.html" class="nav-link active">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Main User</p>
                                    </a>
                                </li>
                            </ul>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>

        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">
            <div class="container">
                <h3 class="text-center">F100-QUẢN TRỊ NGƯỜI DÙNG</h3>
                <div class="row bg-secondary">
                    <label class="row-3">Role</label>
                    <select class="bg-primary form-control" id="select-role">
                        <option value="0">None</option>
                    </select>
                    <button class="btn btn-success class-5" id="filter-btn">Lọc dữ liệu</button>
                </div>
                <table id="user-table" class="table table-hover table-striped table-bordered">
                    <thead class="thead-dark">
                        <tr>
                            <th scope='col'>STT</th>
                            <th scope='col'>Username</th>
                            <th scope='col'>First name</th>
                            <th scope='col'>Last name</th>
                            <th scope='col'>Email</th>
                            <th scope='col'>Age</th>
                            <th scope='col'>Role</th>
                            <th scope='col'>Action</th>
                        </tr>
                    </thead>
                </table>
            </div>
        </div>
        <!-- /.content-wrapper -->
        <footer class="main-footer">
            <strong>Copyright &copy; 2023 <a href="https://adminlte.io">User Signed up</a>.</strong>
            All rights reserved.
            <div class="float-right d-none d-sm-inline-block">
                <b>Version</b> 3.2.0
            </div>
        </footer>

        <!-- Control Sidebar -->
        <aside class="control-sidebar control-sidebar-dark">
            <!-- Control sidebar content goes here -->
        </aside>
        <!-- /.control-sidebar -->
    </div>
    <!-- ./wrapper -->



    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- jQuery UI 1.11.4 -->
    <script src="plugins/jquery-ui/jquery-ui.min.js"></script>
    <!-- Resolve conflict in jQuery UI tooltip with Bootstrap tooltip -->
    <script>
        $.widget.bridge('uibutton', $.ui.button)
    </script>
    <!--DataTable-->
    <script src="https://cdn.datatables.net/1.13.6/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.6/js/dataTables.bootstrap4.min.js"></script>

    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- ChartJS -->
    <script src="plugins/chart.js/Chart.min.js"></script>
    <!-- Sparkline -->
    <script src="plugins/sparklines/sparkline.js"></script>
    <!-- JQVMap -->
    <script src="plugins/jqvmap/jquery.vmap.min.js"></script>
    <script src="plugins/jqvmap/maps/jquery.vmap.usa.js"></script>
    <!-- jQuery Knob Chart -->
    <script src="plugins/jquery-knob/jquery.knob.min.js"></script>
    <!-- daterangepicker -->
    <script src="plugins/moment/moment.min.js"></script>
    <script src="plugins/daterangepicker/daterangepicker.js"></script>
    <!-- Tempusdominus Bootstrap 4 -->
    <script src="plugins/tempusdominus-bootstrap-4/js/tempusdominus-bootstrap-4.min.js"></script>
    <!-- Summernote -->
    <script src="plugins/summernote/summernote-bs4.min.js"></script>
    <!-- overlayScrollbars -->
    <script src="plugins/overlayScrollbars/js/jquery.overlayScrollbars.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.js"></script>
    <!-- AdminLTE for demo purposes -->
    <script src="dist/js/demo.js"></script>
    <!-- AdminLTE dashboard demo (This is only for demo purposes) -->
    <script src="dist/js/pages/dashboard.js"></script>
    <script>
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

        const gDATA = ['id', 'username', 'firstname', 'lastname', 'email', 'age', 'roleId', 'action'];
        const gID_COL = 0;
        const gUSER_NAME_COL = 1;
        const gFIRST_NAME_COL = 2;
        const gLAST_NAME_COL = 3;
        const gEMAIL_COL = 4;
        const gAGE_COL = 5;
        const gROLE_ID_COL = 6;
        const gACTION_COL = 7;
        // Mảng gUserObjects là mảng chứa dữ liệu users
        var gUserObjects = [
            {
                id: 2,
                username: "quannv",
                firstname: "Ngo Van",
                lastname: "Quan",
                age: 18,
                email: "quan@gmail.com",
                roleId: 5
            },
            {
                id: 3,
                username: "longdh",
                firstname: "Do Hoang",
                lastname: "Long",
                age: 19,
                email: "long@gmail.com",
                roleId: 8
            },
            {
                id: 4,
                username: "hiendt",
                firstname: "Do Thi",
                lastname: "Hien",
                age: 29,
                email: "hien@gmail.com",
                roleId: 11
            },
            {
                id: 6,
                username: "lanht",
                firstname: "Ho Thi",
                lastname: "Lan",
                age: 27,
                email: "lan@gmail.com",
                roleId: 13
            }
        ];
        // Mảng gRoleObjects là mảng chứa dữ liệu các roles
        var gRoleObjects = [
            {
                roleId: 5,
                roleName: "Admin"
            },
            {
                roleId: 8,
                roleName: "Manager"
            },
            {
                roleId: 11,
                roleName: "Teacher"
            },
            {
                roleId: 13,
                roleName: "Staff"
            }
        ];

        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        $(document).ready(function () {
            onPageLoading();
            $("#filter-btn").on('click', function () {
                onBtnFilterClick();
            })
            $("#user-table").on("click", ".dice-history", function () {
                onDiceHistoryBtnClick(this);
            })
        })
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
            renderTable();
            loadToSelectRole();
        }

        function onDiceHistoryBtnClick(paramElement) {
            var vTable = $("#user-table").DataTable();
            var vRow = $(paramElement).parents("tr");
            var vData = vTable.row(vRow).data();

            var vDiceHistoryPlace = "diceHistory.html";
            var url = vDiceHistoryPlace + "?"
                + "user_name=" + vData.username
                + "&first_name=" + vData.firstname
                + "&last_name=" + vData.lastname;
            location.href = url;
        }

        function onBtnFilterClick() {
            var vUserFilter = gUserObjects.filter(filterUserBySelect);
            console.log(vUserFilter);

            gStt = 1;
            var vTable = $("#user-table").DataTable();
            vTable.clear();
            vTable.rows.add(vUserFilter);
            vTable.draw();
        }

        function filterUserBySelect(paramObjectElement) {
            return paramObjectElement.roleId == $("#select-role").val();
        }

        function loadToSelectRole() {
            for (var bI = 0; bI < gRoleObjects.length; bI++) {
                $("<option/>", {
                    html: gRoleObjects[bI].roleName,
                    value: gRoleObjects[bI].roleId
                }).appendTo($("#select-role"));
            }
        }

        function mappingRoleNameByID(paramData, paramType, paramRow) {
            for (let bI = 0; bI < gRoleObjects.length; bI++) {
                const bRoleObjItem = gRoleObjects[bI];
                if (paramData == bRoleObjItem.roleId) {
                    return bRoleObjItem.roleName;
                }
            }
        }

        function renderTable() {
            gStt = 1;
            var vTable = $("#user-table").DataTable({
                data: gUserObjects,
                columns: [
                    { data: gDATA[gID_COL] },
                    { data: gDATA[gUSER_NAME_COL] },
                    { data: gDATA[gFIRST_NAME_COL] },
                    { data: gDATA[gLAST_NAME_COL] },
                    { data: gDATA[gEMAIL_COL] },
                    { data: gDATA[gAGE_COL] },
                    { data: gDATA[gROLE_ID_COL] },
                    { data: gDATA[gACTION_COL] },
                ],
                columnDefs: [
                    {
                        targets: gID_COL,
                        render: () => {
                            return gStt++;
                        }
                    },
                    {
                        targets: gROLE_ID_COL,
                        className: "text-right",
                        render: mappingRoleNameByID
                    },
                    {
                        targets: gACTION_COL,
                        className: "text-success",
                        defaultContent: `
                <button class="btn btn-link dice-history" data-toggle="tooltip" data-placement="bottom" title="Dice History"><i class="fas fa-dice text-success"></i></button>
                <button class="btn btn-link" data-toggle="tooltip" data-placement="bottom" title="Dice Present"><i class="fas fa-gift  text-success"></i></button>`
                    }
                ]
            })
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    </script>

</body>


</html>